module Trader
  class RawResource
    def self.enforce_attr(*_attrs)
      _attrs.each do |att|
        define_method(att) do
          raise NotImplementedError, "#{att} was not implemented by backend"
        end
      end
    end

    def self.attr_mapped(_attr, _path=nil, &_block)
      define_method(_attr) do
        if _block
          _block.call(raw)
        elsif _path
          raw[_path]
        else
          raw[_attr.to_s]
        end
      end
    end

    attr_reader :raw

    def initialize(_raw)
      @raw = _raw
    end
  end
end