module Trader
  class GameBackend
    module SFM # Safe Float Multiplier (wtf)
      extend self

      FACTOR = 1_000_000

      def quote(_volume, _price)
        (_volume * _price) / FACTOR
      end

      def encode(_amount)
        return nil if _amount.nil?
        (_amount * FACTOR).to_i
      end

      def decode(_amount)
        return nil if _amount.nil?
        _amount.to_f / FACTOR
      end
    end
  end
end