require 'gli'

module Trader
  class CLI
    extend GLI::App

    program_desc 'Trader command line interface'

    desc "Executes a trade-o-matic enviroment"
    command [:console, :r] do |c|

      c.desc "Specifies the robot configuration file"
      c.flag [:c, :config]

      c.action do |global_options,options,args|

        config = YAML.load_file options[:config]

        # TODO: load accounts from config file
        # TODO: start a REPL in loaded accounts context
      end
    end

    on_error do |exc|
      puts exc.to_s
      puts exc.backtrace

      false
    end

    exit run(ARGV)
  end
end
