require 'rest-client'
require 'json'

module Trader
  class JsonApiConverter < SyncConverter
    attr_reader :url, :path

    def initialize(_url, _path, _ttl=30)
      @url = _url
      @path = _path

      super(_ttl) do
        json_string = RestClient.get _url
        json = JSON.parse json_string
        value = _path.inject(json) { |r, k| r[k] }
        Standard.amount value
      end
    end
  end
end