module Trader
  class SyncConverter < FixedConverter
    attr_reader :ttl

    def initialize(_ttl, &_block)
      super nil
      @ttl = _ttl
      @block = _block
    end

    def expired?
      @rate.nil? || @last_sync < (Time.now - @ttl)
    end

    def rate
      if expired?
        @rate = @block.call
        @last_sync = Time.now
      end
      @rate
    end
  end
end