module Trader
  class Market < Book
    attr_reader :backend

    def initialize(_backend, _pair)
      super _pair
      @backend = _backend
    end

    def book
      self
    end

    def base_currency
      pair.base
    end

    def quote_currency
      pair.quote
    end

    def refresh!
      backend.fill_book(book)
      self
    end

    def on_transaction
      backend.listen_transactions(pair) do |raw|
        yield TransactionEvent.new raw, nil
      end
    end
  end
end

