module Trader
  class Error < StandardError; end

  class AssertError < Error; end

  class BackendError < Error
    attr_reader :backend

    def initialize(_backend, _message)
      super "#{_backend}: #{_message}"
      @backend = _backend
    end
  end

  class NotSupportedError < BackendError
    attr_reader :feature

    def initialize(_backend, _feature)
      super _backend, "#{_feature} not supported"
      @feature = _feature
    end
  end
end