module Trader
  class CurrencyPair
    attr_reader :base, :quote

    def self.parse(_string)
      new *(_string.split '/')
    end

    def self.for_code(_pair, _quote=nil)
      return _pair if _pair.is_a? self
      self.new _pair, _quote
    end

    def initialize(_base, _quote)
      @base = Currency.for_code _base
      @quote = Currency.for_code _quote
    end

    def ==(_other)
      return false unless _other.is_a? CurrencyPair
      base == _other.base and quote == _other.quote
    end

    def convertible_to?(_pair, _quote=nil)
      _pair = for_code _pair, _quote
      base.convertible_to?(_pair.base) and quote.convertible_to?(_pair.quote)
    end

    def compatible_with?(_pair, _quote=nil)
      _pair = for_code _pair, _quote
      base.compatible_with?(_pair.base) and quote.compatible_with?(_pair.quote)
    end

    def to_s
      "#{base}/#{quote}"
    end

    private

    def for_code(_pair, _quote=nil)
      self.class.for_code _pair, _quote
    end
  end
end