module Trader
  class Order
    BID = :bid
    ASK = :ask

    def self.new_bid(_pair, _volume, _price = nil)
      new _pair, BID, _volume, _price
    end

    def self.new_ask(_pair, _volume, _price = nil)
      new _pair, ASK, _volume, _price
    end

    attr_accessor :pair, :instruction

    def initialize(_pair, _instruction, _volume, _price)
      @pair = _pair
      @instruction = _instruction
      self.volume = _volume
      self.price = _price
    end

    def limit?
      !@price.nil?
    end

    def market?
      !limit?
    end

    def volume
      pair.base.pack @volume
    end

    def volume=(_value)
      @volume = pair.base.unpack(_value, strict: false)
    end

    def price
      limit? ? pair.quote.pack(@price) : nil
    end

    def price=(_value)
      @price = _value.nil? ? nil : pair.quote.unpack(_value, strict: false)
    end

    def convert_to(_pair, _quote = nil)
      _pair = CurrencyPair.for_code _pair, _quote

      return self if _pair == pair

      self.class.new(_pair, instruction, volume, price)
    end
  end
end